import os
from os.path import isdir, join, basename, realpath

def grab_uid(pool_dir):
    assert os.access(pool_dir, os.W_OK) and isdir(pool_dir)
    uid = 1000
    fd = None
    while uid < 65534:
        try:
            fd = os.open(join(pool_dir, str(uid)),
                         os.O_EXCL | os.O_CREAT, 
                         0600)
            os.close(fd)
            break
        except OSError:
            uid += 1
    if fd is None:
        raise RuntimeError("No uids available.")
    return uid

def grab_gid(pool_dir, gid_dir, name):
    assert os.access(pool_dir, os.W_OK) and isdir(pool_dir)
    assert os.access(pool_dir, os.W_OK) and isdir(gid_dir)
    # Pick a gid for yourself.
    gid = 1000
    fd = None
    while gid < 65534:
        try:
            fd = os.open(join(pool_dir, str(gid)),
                         os.O_EXCL | os.O_CREAT, 
                         0600)
            os.close(fd)
            break
        except OSError:
            gid += 1
    if fd is None:
        raise RuntimeError("No gids available.")
    # Then try to atomically symlink the gid you picked to 'name' in gid_dir.
    # If you succeed, then you have the right gid.
    # If you fail, someone else has the right gid so release yours and use theirs.
    name_path = join(gid_dir, name)
    gid_path = join(pool_dir, str(gid))
    try:
        os.symlink(gid_path, name_path)
        return gid
    except OSError:
        os.unlink(gid_path)
        return int(basename(realpath(name_path)))
            

    
